

#warning "zakres PWM"
// 1..2ms (1.5 neutralana)
// 0,3..2,3ms


#define	SALEAE


#define BAUD 			250000
#define BAUD1 			250000
#include <rmik/include.h>


#define	LedStDir()		DDRC	|=  (1 << PC6 )
#define LedStOff()		PORTC	|=  (1 << PC6 )
#define LedStOn()		PORTC	&= ~(1 << PC6 )
#define LedStEor()		PORTC	^=  (1 << PC6 )

#define	LedDmxDdr()		DDRC  |=  (1<<PC7)
#define	LedDmxOn()		PORTC &= ~(1<<PC7)
#define	LedDmxOff()		PORTC |=  (1<<PC7)
#define	LedDmxEor()		PORTC ^=  (1<<PC7)

#define	LedErrDdr()		DDRC  |=  (1<<PC0)
#define	LedErrBUS()		TimerErr = 50/8; PORTC &= ~(1<<PC0)	// Wczenie diody na 100ms
#define	LedErrINIT()	TimerErr = 2000/8; PORTC &= ~(1<<PC0)	// Wczenie diody na 100ms
#define	LedErrOff()		PORTC |=  (1<<PC0)
#define	LedErrEor()		PORTC ^=  (1<<PC0)


#define	DdrA0()		PORTA |=(1<<PA0)			// Wlacz podciaganie
#define	RdA0()		(PINA & (1<<PA0))
#define	DdrA1()		PORTA |=(1<<PA1)
#define	RdA1()		(PINA & (1<<PA1))
#define	DdrA2()		PORTA |=(1<<PA2)
#define	RdA2()		(PINA & (1<<PA2))
#define	DdrA3()		PORTA |=(1<<PA3)
#define	RdA3()		(PINA & (1<<PA3))
#define	DdrA4()		PORTA |=(1<<PA4)
#define	RdA4()		(PINA & (1<<PA4))
#define	DdrA5()		PORTA |=(1<<PA5)
#define	RdA5()		(PINA & (1<<PA5))
#define	DdrA6()		PORTA |=(1<<PA6)
#define	RdA6()		(PINA & (1<<PA6))
#define	DdrA7()		PORTA |=(1<<PA7)
#define	RdA7()		(PINA & (1<<PA7))
#define	DdrA8()		PORTB |=(1<<PB0)
#define	RdA8()		(PINB & (1<<PB0))

//----- Zworka zalozona to pojedyncza transmisja jest akceptowana, brak zworki: to dwie identyczne transmisje zmienia stan wyjscia
#define	DdrCfgSingle()	PORTB |=(1<<PB1)			// Wlacz podciaganie
#define	RdCfgSingle()	(PINB & (1<<PB1))

//----- Zworka zalozona to przy braku transmiji wyjscia wylaczane, brak zworki: wyjscie pamieta ostatni stan
#define	DdrCfgMem()		PORTB |=(1<<PB2)			// Wlacz podciaganie
#define	RdCfgMem()		(PINB & (1<<PB2))

#define	DdrCfgNeutral()	PORTB |= _BV(PB5)
#define	RdCfgNeutral()	(PINB & _BV(PB5))

#define	DdrCfg2ms()		PORTB |= _BV(PB4)
#define	RdCfg2ms()		(PINB & _BV(PB4))

// rozdzielczo PWM 1:		0,031ms (8ms/1024*4)
// rozdzielczo PWM 0 i 2:	0,125ms (8ms/1024*4)
// Rozdzielczo dla 16MHz dwa razy wiksza (0,016 i 0,625us)
// 0,5ms	0x40 #64
// 1ms		0x80 #128
// 1,5ms	0xC0 #192
// 2ms		0xFF #255
#if F_CPU == 8000000
  #define	IMP_MIN		(64-2)
  #define	IMP_MAX		(192-5)
  #define	TIM1_DIV	2	// Podzielnik dla 20ms (24ms)
  #define	TIM0_DIV	10	// Podzielnik dla 20ms (24ms)
#elif F_CPU == 16000000
  #define	IMP_MIN		((64*2)-4)
  #define	IMP_MAX		((192*2)-10)
  #define	TIM1_DIV	4	// Podzielnik dla 20ms
  #define	TIM0_DIV	16	// Podzielnik dla 20ms (24ms)
#else
  #error "Moze na 4MHz albo kwarcu UART'owym chcial bys uruchomic?"
#endif
#define	IMP_MID			(IMP_MAX-IMP_MIN)/2 + IMP_MIN


void InitUart();
void SetServo1( byte pwm );
void SetServo2( byte pwm );
void SetServo3( byte pwm );
void SetServo4( byte pwm );
byte PwmCalculate( byte pwm );


word ReadAdrDMX();
word AdrDMX=0;
#define	LENTABDATA	4
byte volatile TabPwm[ LENTABDATA ];
byte volatile ErrI=0;
#define	OVERTIME_DMX	1 * 100		// Liczba sekund do trybu ofline w 10ms
byte volatile TimerDmx;
word volatile TimerErr;


#define	MIN_DMX_OFLINE	1			// Czas braku transmisji w sekundach, uznany jako brak sygnalu DMX
enum{DMX_OFFLINE, DMX_BREAK};
byte DmxStatus = DMX_OFFLINE;


//=======================================================================//
//=						Fuses											=//
//=======================================================================//
__fuse_t __fuse __attribute__((section (".fuse"))) =
{
#if defined(__AVR_ATmega16A__) || defined(__AVR_ATmega16P__)
	.high = 0x99,
	.low = 0xAF
#else
  #error "Nieznany typ CPU"
#endif
};


//=======================================================================//
void main()
{
#ifdef	SALEAE
  DDRD |= _BV(PD2) | _BV(PD3) | _BV(PD6);
#endif

	DDRB  |= _BV(PB3); DDRD	|= _BV(PD4) | _BV(PD5) | _BV(PD7);	// Pwm Out

	LedStDir(); LedDmxDdr(); LedErrDdr();

	DdrCfg2ms(); DdrCfgSingle(); DdrCfgMem(); DdrCfgNeutral();
	DdrA0(); DdrA1(); DdrA2(); DdrA3(); DdrA4(); DdrA5(); DdrA6(); DdrA7(); DdrA8();


	wdt_enable( WDTO_500MS );			// Ustawienie WDG (IRQ musz byc wyczone)


	TCCR1A |= (2<<COM1B0) | (2<<COM1A0);// 1 lub 2 (zanegowane)
	// Mode 7 (WGM=7) - Fast PWM, 10-bit
	TCCR1A |= (3<<WGM10);	// ustawia WGM 0 i 1
	TCCR1B |= (1<<WGM12);	// Ustawia WGM 2 i 3
	TCCR1B |= (3<<CS10);	// 3 = 8ms, podzielnik=64
	OCR1A = IMP_MID;
	OCR1B = IMP_MAX;


	// Mode 3 - Fast PWM (8-bit) Timerw 0 i 2
	TCCR0 |= _BV(WGM00) | _BV(WGM01);
	TCCR0 |= (2<<COM00);
	TCCR2 |= _BV(WGM21) | _BV(WGM20);
	TCCR2 |= (2<<COM20);
	TCCR0 |= (3<<CS00);		// 3 = 2ms, podzielnik 64
	TCCR2 |= (4<<CS20);		// 4! = 2ms, podzielnik 64
	OCR0 = IMP_MIN;
	OCR2 = IMP_MAX;


	TIMSK |= _BV(OCIE1A) | _BV(OCIE1B);				// Wczenie IRQ COMPA COMPB od Timer1
	TIMSK |= _BV(TOIE0) | _BV(OCIE0) | _BV(OCIE2);	// Wczenie IRQ OVR od Timer0 i COMP0, COMP2 od Timer 0 i 2


	InitUart();


	//==================================//
	//			Ptla gwna			//
	//==================================//
	if ( !RdCfgNeutral() ) TabPwm[0] =	TabPwm[1] = TabPwm[2] = TabPwm[3] = IMP_MID;	// Serwa do pozycji neutralnej

	sei();
	LedErrINIT();
while( true )
	{
	wdg();
#ifdef SALEAE
  PORTD |= _BV(PD2);
  PORTD &= ~_BV(PD2);
#endif


	AdrDMX = ReadAdrDMX();				// odczytaj adres DMX z DIP-switch

	SetServo1( TabPwm[0] );
	SetServo2( TabPwm[1] );
	SetServo3( TabPwm[2] );
	SetServo4( TabPwm[3] );

	if ( DmxStatus == DMX_OFFLINE )		// Obsluga diody led
		{
		LedDmxOff();
		LedStOn();
		if ( RdCfgMem() )				// Jeli nie ma zwornki mem
			{
			if ( RdCfgNeutral() )
				{
				TabPwm[0] =	TabPwm[1] = TabPwm[2] = TabPwm[3] = 0;			// Serwa do pozycji zerowej
				}
			else
				{
				TabPwm[0] =	TabPwm[1] = TabPwm[2] = TabPwm[3] = IMP_MID;	// Serwa do pozycji neutralnej
				}
			}
		}
	else
		{
		LedDmxOn();
		}
	}
}


//=======================================================================//
INTERRUPT(TIMER1_COMPA_vect)
{
byte static div=1;


	if ( !div-- )		// Podzielnik dla 20ms
		{
		div = TIM1_DIV;
		TCCR1A |= (2<<COM1A0);		// Wcz wyjcia PWM 1A
		}
	else
		{
		TCCR1A &= ~(3<<COM1A0);		// Wycz wyjcia PWM 1A
		}
}


//-----------------------------------------------------------------------//
INTERRUPT(TIMER1_COMPB_vect)
{
byte static div=1;


	if ( !div-- )		// Podzielnik dla 20ms
		{
		div = TIM1_DIV;
		TCCR1A |= (2<<COM1B0);		// Wcz wyjcia PWM 1B
byte out;
word static pwm;
pwm++; pwm &= 0x1FF; out = pwm;
if ( pwm & 0x100)
	{
	out = pwm ^ 0xFF;
	}
/*
SetServo1( out );
SetServo2( out );
SetServo3( out^0xFF );
SetServo4( out^0xFF );
*/
		}
	else
		{
		TCCR1A &= ~(3<<COM1B0);		// Wycz wyjcia PWM 1B
		}
}


//-----------------------------------------------------------------------//
void SetServo1( byte pwm )
{
	OCR1A = PwmCalculate( pwm );
}


//-----------------------------------------------------------------------//
void SetServo2( byte pwm )
{
	OCR1B = PwmCalculate( pwm );
}


//=======================================================================//
// Przerwanie co 8ms przy 8MHz, co 4ms przy 16MHz
//-----------------------------------------------------------------------//
INTERRUPT(TIMER0_OVF_vect)
{
	if ( !TimerDmx--) DmxStatus = DMX_OFFLINE;
	if ( !TimerErr-- ) LedErrOff();
}


//-----------------------------------------------------------------------//
INTERRUPT(TIMER0_COMP_vect)
{
byte static div=1;


	if ( !div-- )							// Podzielnik dla 20ms
		{
		div = TIM0_DIV;
		TCCR0 |= _BV(WGM00) | _BV(WGM01);	// Wycz wyjcia PWM 0
		}
	else
		{
		TCCR0 &= ~_BV(WGM00) & ~_BV(WGM01);	// Wcz wyjcia PWM 0
		}


}


//-----------------------------------------------------------------------//
void SetServo4( byte pwm )
{
	OCR0 = PwmCalculate( pwm );

}


//-----------------------------------------------------------------------//
void SetServo3( byte pwm )
{
	OCR2 = PwmCalculate( pwm );
}


//=======================================================================//
INTERRUPT(TIMER2_COMP_vect)
{
byte static div=1;


	if ( !div-- )							// Podzielnik dla 20ms
		{
		div = TIM0_DIV;
		TCCR2 |= _BV(WGM20) | _BV(WGM21);	// Wycz wyjcia PWM 2
		}
	else
		{
		TCCR2 &= ~_BV(WGM20) & ~_BV(WGM21);	// Wcz wyjcia PWM 2
		}
}


//=======================================================================//
byte PwmCalculate( byte pwm )
{
	#if F_CPU == 8000000
	  if ( RdCfg2ms() )
		{
		return( (pwm>>1) + IMP_MIN );				// 0,5..1,5ms
		}
	  else
		{
		return( (pwm>>1) + IMP_MIN + (pwm>>2) );	// 0,5..2ms
		}
	#elif F_CPU == 16000000
#error "Trzeba zrobic obliczenia dla 16MHz"
	  return( pwm + IMP_MIN );
	#endif
}


//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart()
{
#if F_CPU == 16000000
	UBRRH = 0;
	UBRRL = 3;			// Dla 16MHz
	UCSRA = 0;
#elif F_CPU == 8000000
	UBRRH = 0;			// Dla 8MHz
	UBRRL = 1;			// Tablica 19-11 str 196
	UCSRA = 0;
//	UBRRL = 3;			// Tablica 19-11 str 196
//	UCSRA = (1<<U2X0);
#else
 #error "Nieznane FCLK"
#endif
	UCSRB = (1<<RXEN) | (1<<RXCIE) | (1<<TXCIE);
	UCSRC = (1<<URSEL) | (1<<USBS) | (3<<UCSZ0);					// Set frame format: 8data, 2stop bit
}


//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
#define	MAXERR	2
SIGNAL( USART_RXC_vect )			// Nie mozliwe przerwanie wielopoziomowe
{
byte UsartStatus, UsartDana;
byte static Err=MAXERR, lastDana[ LENTABDATA ];
word static CntDanych=0;
byte x, temp;
static byte tdmx[513];


#ifdef SALEAE
  PORTD &= ~_BV(PD6);
#endif
	UsartStatus = UCSRA;
	UsartDana = UDR;
//	UCSRA = 0;


	if ( (UsartStatus & (1<<FE)) )				// Jesli wykryto blad ramki to skonczyl sie sygnal BREAK
		{
		DmxStatus = DMX_BREAK;					// Ustaw status
		CntDanych = 0;							// Zeruj licznik danych
		if ( tdmx[ 0 ] )						// Jeli CS rny od zera
			{
			LedErrBUS();
			}
		else									// Jeli CS rwny zero
			{
			TimerDmx = OVERTIME_DMX;
			for(x=0; x<LENTABDATA; x++)			// Przepisanie danych z tablicy DMX do tablicy PWM
				{
				temp = tdmx[ x + AdrDMX/* + 1*/ ];	// Zapamitujemy dan
				if ( ! RdCfgSingle() )			// Jeli jest zwora
					{
					TabPwm[ x ] = temp;			// Przepisujemy wynik do tablicy PWM
					}
				if ( lastDana[ x ] == temp )	// Jeli poprzednia dana taka sama jak odczytana teraz
					{
					TabPwm[ x ] = temp;			// Przepisujemy wynik do tablicy PWM
					Err=MAXERR;					// Kasujemy bdy
					}
				else							// Porwnanie bdne
					{
#ifdef SALEAE
  PORTD |= _BV(PD3);
  PORTD &= ~_BV(PD3);
#endif
					if ( !Err-- )
						{
						LedErrBUS();			// Licznymy bdy i sygnalizujemy
						nop();
						}

					}
				lastDana[ x ] = temp;			// Zapamitaj do nastpnego porwnania
				}
			}
#ifdef SALEAE
  PORTD |= _BV(PD6);
#endif
		return;
		}
	else if(DmxStatus == DMX_BREAK)				// Jesli byl BREAK i pojawila sie nowa dana:
		{
		LedStEor();
		if ( CntDanych>513 ) { DmxStatus=DMX_OFFLINE; return; }// Jesli za duzo danych
		}


	tdmx[CntDanych]=UsartDana;
	CntDanych++;
#ifdef SALEAE
  PORTD |= _BV(PD6);
#endif
}


//----------------------------------------------------------------------//
word ReadAdrDMX()
{
word adr=0;


	if ( !RdA0() ) adr |= (1<<0);
	if ( !RdA1() ) adr |= (1<<1);
	if ( !RdA2() ) adr |= (1<<2);
	if ( !RdA3() ) adr |= (1<<3);
	if ( !RdA4() ) adr |= (1<<4);
	if ( !RdA5() ) adr |= (1<<5);
	if ( !RdA6() ) adr |= (1<<6);
	if ( !RdA7() ) adr |= (1<<7);
	if ( !RdA8() ) adr |= (1<<8);

	if (adr==0) adr=512;

	return( adr );
}


//----------------------------------------------------------------------//
